// Language Level Converter line number map: dj*->java. Entries: 36
//     1->7         2->8         3->9         4->10        5->11        6->12        7->13        8->14   
//     9->15       10->16       11->17       12->18       13->19       14->20       15->21       16->60   
//    17->61       18->62       19->63       20->64       21->65       22->66       23->67       24->68   
//    25->69       26->95       27->96       28->97       29->98       30->99       31->100      32->101  
//    33->102      34->103      35->104      36->105  
/** Visitor class for composite IntList ::= EmptyIntList | ConsIntList(int, IntList) */
interface IntListVisitor {
  public Object forEmptyIntList(final EmptyIntList host);  /* abstract modifier is implicit */
  public Object forConsIntList(final ConsIntList host);    /* abstract modifier is implicit */                 
}

class InsertVisitor implements IntListVisitor {
  private final int elt;
  public IntList forEmptyIntList(final EmptyIntList host) { return host.cons(elt); }
  public IntList forConsIntList(final ConsIntList host) {
    if (elt <= host.first()) return host.cons(elt);
    final IntList insertedRest = (IntList) host.rest().accept(this);
    return insertedRest.cons(host.first());
  }                      

  /** This method is automatically generated by the Language Level Converter. */
  public InsertVisitor(int elt) {
    super();
    this.elt = elt;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int elt() {
    return elt;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        elt() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      InsertVisitor cast = ((InsertVisitor) o);
      return (elt() == cast.elt());
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        elt();
  }
}

class SortVisitor implements IntListVisitor {
  public final static SortVisitor ONLY = new SortVisitor();
  private SortVisitor() { }
  public IntList forEmptyIntList(final EmptyIntList host) { return host; }
  public IntList forConsIntList(final ConsIntList host) {
    final IntList sortedRest = (IntList) host.rest().accept(this);
    return (IntList) sortedRest.accept(new InsertVisitor(host.first()));
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      SortVisitor cast = ((SortVisitor) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}
 
class MaxVisitor implements IntListVisitor {
  public final static IntListVisitor ONLY = new MaxVisitor();
  private MaxVisitor() { }
  public Integer forEmptyIntList(final EmptyIntList host) { 
    throw new IllegalArgumentException("max cannot be applied to the EmptyIntList"); 
  }
  public Integer forConsIntList(final ConsIntList host) { 
    if (host.rest().equals(EmptyIntList.ONLY)) return host.first();
    return Math.max(host.first(), (Integer)(host.rest().accept(this))); }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      MaxVisitor cast = ((MaxVisitor) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}
