// Language Level Converter line number map: dj*->java. Entries: 43
//     1->8         2->9         3->10        4->11        5->12        6->13        7->14        8->15   
//     9->16       10->17       11->18       12->19       13->20       14->21       15->22       16->23   
//    17->24       18->25       19->26       20->57       21->58       22->59       23->60       24->61   
//    25->62       26->63       27->64       28->65       29->66       30->67       31->68       32->94   
//    33->95       34->96       35->97       36->98       37->99       38->100      39->101      40->102  
//    41->103      42->104      43->105  
/** Composite representation of IntList ::= EmptyIntList | ConsIntList(int, IntList) with visitor interface. */
/** IntList ::= EmptyIntList | ConsIntList(int, IntList).*/
interface IntListVisitor {
  public Object forEmptyIntList(final EmptyIntList host);
  public Object forConsIntList(final ConsIntList host);
}

abstract class IntList {
  /** Hook for applying visitor operations. */
  public abstract Object accept(final IntListVisitor v);
  /** Adds the int n to the front of this IntList. */
  public IntList cons(final int n) { return new ConsIntList(n, this); }
     
  /** Returns a String representation of this ObjectList in Scheme format: (e1 ... en) . */
  public abstract String listString();
  /** Returns s String containing the elements of this ObjectList, where each element is preceded by ' '.  Hence,
    * (e1 e2... en) generates " e1 e2 ... en" */ 
  public abstract String listStringHelp();

  /** This method is automatically generated by the Language Level Converter. */
  public IntList() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntList cast = ((IntList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class EmptyIntList extends IntList { 
  /** Field containing the only (singleton) EmptyIntList. */
  public final static EmptyIntList ONLY = new EmptyIntList();
  /** Constructor used to create ONLY (this). */
  private EmptyIntList() { }

  public Object accept(final IntListVisitor v) { return v.forEmptyIntList(this); }  
  
  public String listString() { return "()"; }
  public String listStringHelp() { return ""; }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      EmptyIntList cast = ((EmptyIntList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class ConsIntList extends IntList {
  /** The first element of this. */
  private final int first;
  /** The remaining elements of this. */
  private final IntList rest;
  
  public Object accept(final IntListVisitor v) { return v.forConsIntList(this); }
  
  public String listString() { return "(" + first + rest.listStringHelp() + ")"; }
  public String listStringHelp() { return " " + first + rest.listStringHelp(); }

  /** This method is automatically generated by the Language Level Converter. */
  public ConsIntList(int first, IntList rest) {
    super();
    this.first = first;
    this.rest = rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int first() {
    return first;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public IntList rest() {
    return rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        first() + ", " + 
        rest() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ConsIntList cast = ((ConsIntList) o);
      return (first() == cast.first()) && 
          (rest() != null && rest().equals(cast.rest()));
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        first() ^ 
        (rest() == null ? 0 : rest().hashCode());
  }
}
