;; The first three lines of this file were inserted by DrScheme. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-lambda-reader.ss" "lang")((modname |13|) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
;; A (genList X) where does not include any members of type (listOf any) is either:
;; * empty;
;; * (cons x agl) where x is a member of X and agl is a (genList X);
;; * (cons agl1 agl2) where agl1 and agl2 are (genList X)

;; Examples of genListOf symbol
;; empty
;; (list empty)
;; (list empty (list 'a (list 'b 'c)))

;; Template
#|
(define (gl-fun ... agl ...)
  (cond [(empty? agl) ...]
        [(empty? (head agl)) ... (gl-fun ... (rest agl) ...) ... ]
        [(cons? (head agl)) ...(gl-fun ... (head agl) ...) ... (gl-fun ... (rest agl) ...) ... ]
        [else (head agl) (gl-fun ... (rest agl) ...) ... ]))
|#

;; In the Template above, the [(empty? (head agl) ...] and [(cons? (head agl) ...] clauses could be replaced by a single clause
;; [(list? agl) ... (gl-fun ... (head agl) ...) ... (gl-fun ... (rest agl) ...) ... ]
;; at the cost of slower execution.  In DrScheme, list? traverses the entire list so it is not a constant time operation.  I don't
;; understand the rationale for this definition because cons prevents non-lists of the form (cons ...) from being created.

;; flatten: (genList X) -> (listOf X) where X does not include any member of type (listOf any)
;; Purpose: (flatten agl) returns the X elements in agl in order of appearance
;; Examples
(check-expect (flatten '(a (b) ((c d)))) '(a b c d))
(check-expect (flatten empty) empty)
(check-expect (flatten '(() a)) '(a))
(check-expect (flatten '(a)) '(a))
(check-expect (flatten '((a))) '(a))

;; Template Instantiation
#|
(define (flatten agl)
  (cond [(empty? agl) ...]
        [(empty? (head agl) ... (flatten (rest agl)) ... ]
        [(cons? (head agl)) ... (flatten (head agl)) ... (flatten (rest agl)) ... ]
        [else ... (head agl) ... (flatten (rest agl)) ...]))
|#

(define (flatten agl)
  (cond [(empty? agl) empty]
        [else (local [(define head (first agl))
                      (define tail (flatten (rest agl)))]
                (cond [(empty? head) tail]
                      [(cons? head) (append (flatten head) tail)]
                      [else (cons head tail)]))]))

;; flatten-help: (genListOf X) (listOf X) -> (listOf X) where X contains no members of (listOf any)
;; Purpose: (flatten-help agl lox) appends the X elements of agl (in order of appearance) to lox

;; Examples
(check-expect (flatten-help '(a (b) ((c d))) '(e)) '(a b c d e))
(check-expect (flatten-help empty empty) empty)
(check-expect (flatten-help '(a) '(b)) '(a b))
(check-expect (flatten-help '((a))'(b)) '(a b))
(check-expect (flatten-help '(() a) '(b)) '(a b))

;; Template Instantiation
#|
(define (flatten-help agl lox)
  (cond [(empty? agl) ...]
        [(empty? (head agl) ... (flatten-help (rest agl) lox) ... ]
        [(cons? (head agl)) ... (flatten-help (head agl) ..) ... (flatten-help (rest agl) ..) ... ]
        [else ... (head agl) ... (flatten-help (rest agl) ..) ...]))
|#
;; Note; the notation (flatten-help E ..) means that the second argument to flatten-help has not yet been determined

(define (flatten-help agl los)
  (cond [(empty? agl) los]
        [else (local [(define head (first agl))
                      (define tail (flatten-help (rest agl) los))]
                (cond [(empty? head)  tail]
                      [(cons? head)  (flatten-help head tail)]
                      [else  (cons head tail)]))]))

;; fast-flatten: (genList X) -> (listOf X) where X does not include any member of type (listOf any)
;; Purpose: (fast-flatten agl) returns the X elements in agl in order of appearance
;; Examples
(check-expect (fast-flatten '(a (b) ((c d)))) '(a b c d))
(check-expect (fast-flatten empty) empty)
(check-expect (fast-flatten '(() a)) '(a))
(check-expect (fast-flatten '(a)) '(a))
(check-expect (fast-flatten '((a))) '(a))

(define (fast-flatten agl) (flatten-help agl empty))