// Language Level Converter line number map: dj*->java. Entries: 48
//     1->8         2->9         3->10        4->11        5->12        6->13        7->14        8->15   
//     9->16       10->33       11->34       12->35       13->36       14->37       15->38       16->39   
//    17->56       18->57       19->58       20->59       21->60       22->61       23->62       24->79   
//    25->80       26->81       27->112      28->113      29->114      30->115      31->116      32->117  
//    33->118      34->119      35->145      36->146      37->147      38->148      39->149      40->150  
//    41->151      42->152      43->153      44->154      45->220      46->221      47->222      48->223  
/* BinaryTree ::= EmptyTree | NonEmptyTree(double, Object) */

abstract class BinaryTree { 
  public double sum() { 
    return (Double) map(new TreeFunction() { 
      public Object apply(final double key, final Object value, final Object left, final Object right) { 
        return key + ((Double) left) + ((Double) right);
      }
    
                          /** This method is automatically generated by the Language Level Converter. */
                          public java.lang.String toString() {
                            return getClass().getName() + "(" + 
                                ")";
                          }

                          /** This method is automatically generated by the Language Level Converter. */
                          public boolean equals(java.lang.Object o) {
                            return (this == o);
                          }

                          /** This method is automatically generated by the Language Level Converter. */
                          public int hashCode() {
                            return getClass().hashCode();
                          }
                        }, 0.); 
  }
  public double maxKey() { 
    return (Double) map(new TreeFunction() { 
      public Object apply(final double key, final Object value, final Object left, final Object right) { 
        return Math.max(key, Math.max((Double) left, (Double) right));
      }
    
                          /** This method is automatically generated by the Language Level Converter. */
                          public java.lang.String toString() {
                            return getClass().getName() + "(" + 
                                ")";
                          }

                          /** This method is automatically generated by the Language Level Converter. */
                          public boolean equals(java.lang.Object o) {
                            return (this == o);
                          }

                          /** This method is automatically generated by the Language Level Converter. */
                          public int hashCode() {
                            return getClass().hashCode();
                          }
                        }, Double.NEGATIVE_INFINITY); 
  }
  public int depth() {
    return (Integer) map(new TreeFunction() {
      public Object apply(final double key, final Object value, final Object left, final Object right) {
        return 1 + Math.max((Integer) left, (Integer) right);
      }
    
                           /** This method is automatically generated by the Language Level Converter. */
                           public java.lang.String toString() {
                             return getClass().getName() + "(" + 
                                 ")";
                           }

                           /** This method is automatically generated by the Language Level Converter. */
                           public boolean equals(java.lang.Object o) {
                             return (this == o);
                           }

                           /** This method is automatically generated by the Language Level Converter. */
                           public int hashCode() {
                             return getClass().hashCode();
                           }
                         }, 0);
  }
  public abstract Object map(final TreeFunction f, final Object init);

  /** This method is automatically generated by the Language Level Converter. */
  public BinaryTree() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      BinaryTree cast = ((BinaryTree) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class EmptyTree extends BinaryTree {
  public static final EmptyTree ONLY = new EmptyTree(); 
  private EmptyTree() { }
  
  public double maxKey() { return Double.NEGATIVE_INFINITY; }
  public Object map(final TreeFunction f, final Object init) { return init; }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      EmptyTree cast = ((EmptyTree) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}                                                                                            

class NonEmptyTree extends BinaryTree {
  private final double key;
  private final Object value;
  private final BinaryTree left;
  private final BinaryTree right;
  
  public double maxKey() { return Math.max(key, right.maxKey()); }  
  public Object map(final TreeFunction f, final Object init) { return f.apply(key, value, left.map(f, init), right.map(f, init)); }

  /** This method is automatically generated by the Language Level Converter. */
  public NonEmptyTree(double key, java.lang.Object value, BinaryTree left, BinaryTree right) {
    super();
    this.key = key;
    this.value = value;
    this.left = left;
    this.right = right;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public double key() {
    return key;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.Object value() {
    return value;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public BinaryTree left() {
    return left;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public BinaryTree right() {
    return right;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        key() + ", " + 
        value() + ", " + 
        left() + ", " + 
        right() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      NonEmptyTree cast = ((NonEmptyTree) o);
      return (key() == cast.key()) && 
          (value() != null && value().equals(cast.value())) && 
          (left() != null && left().equals(cast.left())) && 
          (right() != null && right().equals(cast.right()));
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        (int) key() ^ 
        (value() == null ? 0 : value().hashCode()) ^ 
        (left() == null ? 0 : left().hashCode()) ^ 
        (right() == null ? 0 : right().hashCode());
  }
}

interface TreeFunction {
  public Object apply(final double key, final Object value, final Object left, final Object right);
}
