// Language Level Converter line number map: dj*->java. Entries: 28
//     1->6         2->7         3->8         4->9         5->10        6->11        7->12        8->13   
//     9->14       10->45       11->46       12->47       13->48       14->49       15->50       16->51   
//    17->77       18->78       19->79       20->80       21->81       22->82       23->83       24->84   
//    25->85       26->86       27->87       28->88   
/** ComparableList ::= EmptyComparableList | ConsComparableList(Comparable, ComparableList). */
abstract class ComparableList { 
  /** Sorts this ComparableList into ascending (non-descending) order. */
  public abstract ComparableList sort();
  /** Adds the Comparable n to the front of this ComparableList */
  public ComparableList cons(final Comparable n) { return new ConsComparableList(n, this); }
  /** Inserts n in proper order in this ComparableList, assuming this is sorted in ascending order. */
  public abstract ComparableList insert(final Comparable n);

  /** This method is automatically generated by the Language Level Converter. */
  public ComparableList() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ComparableList cast = ((ComparableList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class EmptyComparableList extends ComparableList {
  public final static EmptyComparableList ONLY = new EmptyComparableList();
  private EmptyComparableList() { }
  public ComparableList sort() { return this; }
  public ComparableList insert(final Comparable n) { return cons(n); }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      EmptyComparableList cast = ((EmptyComparableList) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}

class ConsComparableList extends ComparableList {
  /** The first element of this. */
  private final Comparable first;
  /** The remaining elements of this. */
  private final ComparableList rest;
  public ComparableList sort() { return rest.sort().insert(first); }
  public ComparableList insert(final Comparable n) {
    if (n.compareTo(first) <= 0) return cons(n);
    else return rest.insert(n).cons(first);
  }

  /** This method is automatically generated by the Language Level Converter. */
  public ConsComparableList(java.lang.Comparable first, ComparableList rest) {
    super();
    this.first = first;
    this.rest = rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.Comparable first() {
    return first;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public ComparableList rest() {
    return rest;
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        first() + ", " + 
        rest() + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      ConsComparableList cast = ((ConsComparableList) o);
      return (first() != null && first().equals(cast.first())) && 
          (rest() != null && rest().equals(cast.rest()));
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode() ^ 
        (first() == null ? 0 : first().hashCode()) ^ 
        (rest() == null ? 0 : rest().hashCode());
  }
}
