// Language Level Converter line number map: dj*->java. Entries: 51
//     1->9         2->10        3->11        4->12        5->13        6->14        7->15        8->16   
//     9->17       10->18       11->19       12->20       13->21       14->22       15->23       16->24   
//    17->25       18->26       19->27       20->28       21->29       22->30       23->31       24->32   
//    25->33       26->34       27->35       28->36       29->37       30->38       31->39       32->40   
//    33->41       34->42       35->43       36->44       37->45       38->46       39->47       40->48   
//    41->49       42->50       43->51       44->52       45->53       46->54       47->55       48->56   
//    49->57       50->58       51->59   
import junit.framework.TestCase;

/** Test case class for the IntList composite classes with insert, sort, and merge. */

public class IntListTest extends TestCase {

  public final static IntList E = EmptyIntList.ONLY;
  public final static IntList l1 = E.cons(17);                                                      // '(17)
  public final static IntList l2 = l1.cons(5);                                                      // '(5 17)
  public final static IntList l3 = E.cons(5);                                                       // '(5)
  public final static IntList l4 = l3.cons(5);                                                      // '(5 5)
  public final static IntList l5 = l3.cons(17);                                                     // '(17 5)
  public final static IntList l6 = l5.cons(-5).cons(100).cons(50);                                  // '(50 100 -5 17 5)
  public final static IntList l7 = E.cons(100).cons(50).cons(17).cons(5).cons(-5);                  // '(-5 5 17 50 100)
  public final static IntList l8 = E.cons(20).cons(0);                                              // '(0 20)
  public final static IntList l9 = E.cons(100).cons(50).cons(20).cons(17).cons(5).cons(0).cons(-5); // '(-5 0 5 17 20 50 100)
  
  /** Tests the insert method. */
  public void testInsert() {
    assertEquals("empty insert test", l1, E.insert(17));
    assertEquals("pre insert test", l2, l1.insert(5));
    assertEquals("post insert test", l2, l3.insert(17));
    assertEquals("equals insert test", l4, l3.insert(5));
  }
  /** Tests the Insertion) sort method. */
  public void testSort() {
    assertEquals("empty sort test", E, E.sort());
    assertEquals("one elt test", l1, l1.sort());
    assertEquals("two elts in order test", l2, l2.sort());
    assertEquals("two elts out of order test", l2, l5.sort());
    assertEquals("two equal elts test", l4, l4.sort());
  }
  /** Tests the merge method. */
  public void testMerge() {
    assertEquals("empty both", E, E.merge(E));
    assertEquals("empty this", l3, E.merge(l3));
    assertEquals("empty other", l3, l3.merge(E));
    assertEquals("singletons", l2, l3.merge(l1));
    assertEquals("opposite singletons", l2, l1.merge(l3));
    assertEquals("big merge", l9, l7.merge(l8));
    assertEquals("opposite big merge", l9, l8.merge(l7));
  } 
  
  /** Tests the insert visitor. */
  public void testInsertVisitor() {
    assertEquals("empty insert test", l1, E.accept(new InsertVisitor(17)));
    assertEquals("pre insert test", l2, l1.accept(new InsertVisitor(5)));
    assertEquals("post insert test", l2, l3.accept(new InsertVisitor(17)));
    assertEquals("equals insert test", l4, l3.accept(new InsertVisitor(5)));
  }

  /** This method is automatically generated by the Language Level Converter. */
  public IntListTest() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntListTest cast = ((IntListTest) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}
