// Language Level Converter line number map: dj*->java. Entries: 64
//     1->10        2->11        3->12        4->13        5->14        6->15        7->16        8->17   
//     9->18       10->19       11->20       12->21       13->22       14->23       15->24       16->25   
//    17->26       18->27       19->28       20->29       21->30       22->31       23->32       24->33   
//    25->34       26->35       27->36       28->37       29->38       30->39       31->40       32->41   
//    33->42       34->43       35->44       36->45       37->46       38->47       39->48       40->49   
//    41->50       42->51       43->52       44->53       45->54       46->55       47->56       48->57   
//    49->58       50->59       51->60       52->61       53->62       54->63       55->64       56->65   
//    57->66       58->67       59->68       60->69       61->70       62->71       63->102      64->103  
import junit.framework.TestCase;

/** Test case class for the IntList composite classes with insert and sort methods and
  * InsertVistor, SortVisitor, and MaxVisitor visitors. */

public class IntListTest extends TestCase {

  public final static IntList E = EmptyIntList.ONLY;
  public final static IntList l1 = E.cons(17);                                      // '(17)
  public final static IntList l2 = l1.cons(5);                                      // '(5 17)
  public final static IntList l3 = E.cons(5);                                       // '(5)
  public final static IntList l4 = l3.cons(5);                                      // '(5 5)
  public final static IntList l5 = l3.cons(17);                                     // '(17 5)
  public final static IntList l6 = l5.cons(-5).cons(100).cons(50);                  // '(50 100 -5 17 5)
  public final static IntList l7 = E.cons(100).cons(50).cons(17).cons(5).cons(-5);  // '(-5 5 17 50 100)
  public final static IntList l8 = E.cons(20).cons(0);                              // '(0 20)
  public final static IntList l9 = E.cons(100).cons(50).cons(20).cons(17).cons(5).cons(0).cons(-5); // '(-5 0 5 17 20 50 100)
  
  /** Tests the insert method. */
  public void testInsert() {
    assertEquals("empty insert test", l1, E.insert(17));
    assertEquals("pre insert test", l2, l1.insert(5));
    assertEquals("post insert test", l2, l3.insert(17));
    assertEquals("equals insert test", l4, l3.insert(5));
    final IntList l7And0 = (IntList) l7.insert(0);
    assertEquals("larger insert test", l9, l7And0.insert(20));
  }
  /** Tests the Insertion) sort method. */
  public void testSort() {
    assertEquals("empty sort test", E, E.sort());
    assertEquals("one elt test", l1, l1.sort());
    assertEquals("two elts in order test", l2, l2.sort());
    assertEquals("two elts out of order test", l2, l5.sort());
    assertEquals("two equal elts test", l4, l4.sort());
  }
  
  /** Tests the InsertVisitor operation. */
  public void testInsertVisitor() {
    assertEquals("empty insert test", l1, E.accept(new InsertVisitor(17)));
    assertEquals("pre insert test", l2, l1.accept(new InsertVisitor(5)));
    assertEquals("post insert test", l2, l3.accept(new InsertVisitor(17)));
    assertEquals("equals insert test", l4, l3.accept(new InsertVisitor(5)));
  }
  
  /** Tests the MaxVisitor operation. */
  public void testMaxVisitor() {
    assertEquals("singleton max test", 17, l1.accept(MaxVisitor.ONLY));
    assertEquals("pre insert test", 17, l5.accept(MaxVisitor.ONLY));
    assertEquals("post insert test", 100, l6.accept(MaxVisitor.ONLY));
    assertEquals("post insert test", 100, l7.accept(MaxVisitor.ONLY));
    assertEquals("post insert test", 100, l7.accept(MaxVisitor.ONLY));
  }
  
  /** Tests the SortVisitor operation. */
  public void testSortVisitor() {
    assertEquals("empty sort test", E, E.accept(SortVisitor.ONLY));
    assertEquals("one elt test", l1, l1.accept(SortVisitor.ONLY));
    assertEquals("two elts in order test", l2, l2.accept(SortVisitor.ONLY));
    assertEquals("two elts out of order test", l2, l5.accept(SortVisitor.ONLY));
    assertEquals("two equal elts test", l4, l4.accept(SortVisitor.ONLY));
  }

  /** This method is automatically generated by the Language Level Converter. */
  public IntListTest() {
    super();
  }

  /** This method is automatically generated by the Language Level Converter. */
  public java.lang.String toString() {
    return getClass().getName() + "(" + 
        ")";
  }

  /** This method is automatically generated by the Language Level Converter. */
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    else if ((o == null) || (! o.getClass().equals(getClass()))) {
      return false;
    }
    else {
      IntListTest cast = ((IntListTest) o);
      return true;
    }
  }

  /** This method is automatically generated by the Language Level Converter. */
  public int hashCode() {
    return getClass().hashCode();
  }
}


